﻿using UnityEngine;
using System.Collections;

public class Damage : MonoBehaviour {

    public int OneDamage = 20;
    public bool IsDamage = false;
    private SpriteRenderer sr;
    private int count = 0;

    public GameObject HpBar;

    // Use this for initialization
    void Start() {
        sr = gameObject.GetComponent<SpriteRenderer>();
    }

    // Update is called once per frame
    void Update() {
        if (IsDamage) {
            // 点滅処理
            float l = ((count & 0x2) == 0)? 1.0f : 0.0f;
            sr.color = new Color(1f, 1f, 1f, l);
        }
        count++;
    }

    void OnCollisionEnter2D(Collision2D col) {
        if (!IsDamage && col.gameObject.tag == "Enemy") {
            HpBar.gameObject.SendMessage("OnDamage", OneDamage);
            OnDamageEffect();
        }
    }

    //　ダメージを受けた際の動き
    void OnDamageEffect() {
        IsDamage = true;

        // プレイヤーを後ろに飛ばす
        float s = 100f * Time.deltaTime;
        transform.Translate(Vector3.up * s / 3);

        // localScaleでどちらを向いているか判定
        transform.Translate((transform.localScale.x >= 0) ? Vector3.left * s : Vector3.right * s);

        // コルーチン開始
        StartCoroutine("WaitForIt");
    }

    IEnumerator WaitForIt() {
        // 1秒間処理を止める
        yield return new WaitForSeconds(1);

        // １秒後ダメージフラグをfalseにして点滅を戻す
        IsDamage = false;
        sr.color = new Color(1f, 1f, 1f, 1f);
    }
}
