﻿using UnityEngine;
using System.Collections;

// 敵オブジェクト共通部分
public class EnemyCommon : MonoBehaviour {

    public SpriteRenderer sr;
    public GameObject ParticleBorn;
    public float Life = 3;
    public float LifeMax = 3;
    public float OneDamage = 1;
    public bool isRight = false;
    public bool OnDamage = false;
    public int damageCount = 0;
    public bool Deaded = false;

    protected void Awake() {
        sr = gameObject.GetComponent<SpriteRenderer>();
        OnDamage = false;
        damageCount = 0;
        Deaded = false;
        Life = LifeMax;
    }

    // ダメージ表現
    protected void DispDamage() {
        if ((damageCount & 0x02) == 0) {
            sr.color = new Color(1f, 1f, 1f, 1f);
        }
        else {
            sr.color = new Color(1f, 0f, 0f, 0.5f);
        }
        damageCount++;
    }

    public virtual void OnDamageEffect(float h) {
        OnDamage = true;
        damageCount = 0;
        Life -= OneDamage;
        if (Life <= 0) {
            // HPがゼロになったので爆発処理開始
            SetDead(h);
            Deaded = true;
        }
        else {
            StartCoroutine("WaitForDamage");
        }
    }

    public virtual void SetDead(float h) {
    }

    IEnumerator WaitForDamage() {
        yield return new WaitForSeconds(0.25f);

        OnDamage = false;
        sr.color = new Color(1f, 1f, 1f, 1f);
    }

    // 左右反転させる
    protected void Flip() {
        isRight = !isRight;
        Vector3 theScale = transform.localScale;
        theScale.x *= -1;
        transform.localScale = theScale;
    }
}
