﻿using UnityEngine;
using System.Collections;

// フェードイン・フェードアウト処理
// MainCameraにこのスクリプトを追加して使う
//
// 以下を参考にしました
// 開発メモ 「暗転処理（フェードイン，フェードアウト），メッセージング(SendMessage)」 - シヴァのブログ
// http://shivat.hatenablog.com/entry/2013/06/15/210135
//
public class FadeInOut : MonoBehaviour {
    public Texture2D Tex;
    public float Spd = 0.3f;
    // public float DrawDepth = -1000f;
    public float Alpha = 1.0f;
    public float FadeDir = -1.0f;

	void Start () {
        Alpha = 1.0f;
        FadeIn();
	}
	
	void Update () {
	
	}

    void OnGUI() {
        Alpha += FadeDir * Spd;
        Alpha = Mathf.Clamp01(Alpha);
        GUI.color = new Color(0, 0, 0, Alpha);
        // GUI.depth = DrawDepth;
        GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), Tex);
    }

    public void FadeIn() {
        FadeDir = -1;
    }

    public void FadeOut() {
        FadeDir = 1;
    }
}
