﻿using UnityEngine;
// using System.Collections;

// Singletonを簡単に使う
//
// naichilab - Android iOSアプリ開発メモ: 【Unity】なんちゃらManagerクラスを作ろう(シングルトン)
// http://naichilab.blogspot.jp/2013/11/unitymanager.html
//
// テラシュールウェア [Unity3D]もっと楽なシングルトンの実装
// http://terasur.blog.fc2.com/blog-entry-311.html
//
// Unity勉強　六日目（STG作成開始・シングルトン） - ぼっちプログラマのメモ
// http://pafuhana1213.hatenablog.com/entry/2013/08/13/235259
//
// [Unity]Generic Based Singleton for MonoBehaviours完全版(？) | ケットシーウェア
// http://caitsithware.com/wordpress/?p=118
//
public class SingletonMonoBehaviour<T> : MonoBehaviour where T : MonoBehaviour {
    private static T instance;
    public static T Instance {
        get {
            if (instance == null) {
                System.Type type = typeof(T);
                instance = FindObjectOfType(type) as T;
                if (instance == null) {
                    Debug.LogError(typeof(T) + " is nothing");
                }
            }
            return instance;
        }
    }

    protected void Awake() {
        if (instance == null) {
            instance = this as T;
            DontDestroyOnLoad(this.gameObject);
        }
        else {
            // Debug.LogError(typeof(T) + " exist");
            Destroy(this.gameObject);
        }
    }
}
