﻿using UnityEngine;
using System.Collections;

public class StartButton : MonoBehaviour {
    public string NextSceneName = "";
    public string ButtonText = "";
    private bool pushEnable = false;
    private bool nextScened = false;
    private float timer = 0;

    public GameObject gwk;
    public GameObject fadeManager;

    void Awake() {
    }

    void Start() {
        pushEnable = false;
        nextScened = false;
        timer = 0.5f;

    }

    void Update() {
        if (nextScened || pushEnable) return;

        timer -= Time.deltaTime;
        if (timer > 0) return;

        if (Input.GetKeyDown(KeyCode.Space)
            || Input.GetButtonDown("Fire1")
            || Input.GetButtonDown("Jump")) {
            // ボタンが押されたらフラグを立てる
            pushEnable = true;
        }
    }

    void OnGUI() {
        if (nextScened) return;

        int w = 200;
        int h = 32;
        int x = (Screen.width - w) / 2;
        int y = (Screen.height - h - 32);
        if (GUI.Button(new Rect(x, y, w, h), ButtonText)) pushEnable = true;

        if (pushEnable) {
            // ボタンが押された

            if (GWk.Instance == null)
                Instantiate(gwk);

            if (Application.loadedLevelName == "about") {
                // aboutシーンなら、ゲーム用ワークを初期化
                GWk.PlayerLife = 100;
                GWk.PlayerLifeMax = 100;
            }

            if (FadeManager.Instance == null)
                Instantiate(fadeManager);

            // シーン移行
            // Application.LoadLevel(NextSceneName);
            FadeManager.Instance.LoadLevel(NextSceneName, 0.3f);

            nextScened = true;
        }
    }
}
